import 'reflect-metadata';
import { createRouteHandler } from "./utils";

const registerRoutes = (app, handlerInfos) => {
  handlerInfos.forEach(({
    routePath,
    handler,
    httpMethod
  }) => {
    const routeHandler = createRouteHandler(handler);
    const method = httpMethod.toLowerCase();
    const routeMiddlwares = Reflect.getMetadata('middleware', handler) || [];

    if (routeMiddlwares.length > 0) {
      app[method](routePath, routeMiddlwares, routeHandler);
    } else {
      app[method](routePath, routeHandler);
    }
  });
};

export default registerRoutes;