"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Pipe = exports.Middleware = void 0;

var _context = require("../context");

const Pipe = func => {
  return {
    name: 'pipe',

    // eslint-disable-next-line consistent-return
    async execute(executeHelper, next) {
      const {
        inputs
      } = executeHelper;
      const ctx = (0, _context.useContext)();
      const {
        res
      } = ctx;

      if (typeof func === 'function') {
        let isPiped = true;

        const end = value => {
          isPiped = false;

          if (typeof value === 'function') {
            value(res);
            return;
          } // eslint-disable-next-line consistent-return


          return value;
        };

        const output = await func(inputs, end);

        if (!isPiped) {
          if (output) {
            return executeHelper.result = output;
          } else {
            // eslint-disable-next-line consistent-return
            return;
          }
        }

        executeHelper.inputs = output;
        await next();
      }
    }

  };
}; // eslint-disable-next-line @typescript-eslint/no-redeclare


exports.Pipe = Pipe;

const Middleware = middleware => {
  return {
    name: 'middleware',

    metadata(helper) {
      const middlewares = helper.getMetadata('pipe') || [];
      middlewares.push(middleware);
      helper.setMetadata('middleware', middlewares);
    }

  };
}; // eslint-disable-next-line @typescript-eslint/no-redeclare


exports.Middleware = Middleware;